Tonyu.klass.define({
  fullName: 'user.GameData',
  shortName: 'GameData',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameData_main() {
        "use strict";
        var _this=this;
        
        _this.rank = [{text: "Miss",size: 16,fillStyle: "#ff0000",score: 0},{text: "Perfect",size: 24,fillStyle: "#ffff00",score: 100},{text: "Great",size: 20,fillStyle: "#99ff00",score: 20},{text: "Good",size: 16,fillStyle: "#00ffff",score: 5}];
        
      },
      fiber$main :function _trc_GameData_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.rank = [{text: "Miss",size: 16,fillStyle: "#ff0000",score: 0},{text: "Perfect",size: 24,fillStyle: "#ffff00",score: 100},{text: "Great",size: 20,fillStyle: "#99ff00",score: 20},{text: "Good",size: 16,fillStyle: "#00ffff",score: 5}];
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"rank":{}}}
});
Tonyu.klass.define({
  fullName: 'user.GameMain',
  shortName: 'GameMain',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameMain_main() {
        "use strict";
        var _this=this;
        var _it_190;
        
        _this.streams = [];
        
        _this.interval = 30;
        
        Tonyu.globals.$score=0;
        Tonyu.globals.$totalHit=0;
        Tonyu.globals.$totalZure=0;
        Tonyu.globals.$accuracy=0;
        Tonyu.globals.$accText="";
        new Tonyu.classes.kernel.Label({x: 0,y: 10,align: "left",template: "hit:$totalHit  acc:$accuracy\nScore:$score"});
        _this.t = 0;
        
        while (_this.t<60) {
          Tonyu.checkLoop();
          _this.t++;
          _this.update();
          
        }
        _this.t = 0;
        
        while (true) {
          Tonyu.checkLoop();
          _it_190=Tonyu.iterator(_this.streams,1);
          while(_it_190.next()) {
            _this.st=_it_190[0];
            
            _this.st.Forward();
            
          }
          if (_this.t%300==0) {
            
            if (_this.rnd(3)>0) {
              _this.level=1;
            } else {
              _this.level=2;
            }
            _this.newStream(_this.rnd(200)+100,_this.rnd(200)+100,_this.randomNote(7*_this.level),_this.level);
            
          }
          _this.t++;
          Tonyu.globals.$panel.setFillStyle("#333");
          Tonyu.globals.$panel.fillRect(0,0,400,10);
          Tonyu.globals.$panel.setFillStyle("#ff0");
          Tonyu.globals.$panel.fillRect(0,0,Tonyu.globals.$accuracy*400,10);
          _this.update();
          
        }
      },
      fiber$main :function _trc_GameMain_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_190;
        
        _this.streams = [];
        
        _this.interval = 30;
        
        Tonyu.globals.$score=0;
        Tonyu.globals.$totalHit=0;
        Tonyu.globals.$totalZure=0;
        Tonyu.globals.$accuracy=0;
        Tonyu.globals.$accText="";
        new Tonyu.classes.kernel.Label({x: 0,y: 10,align: "left",template: "hit:$totalHit  acc:$accuracy\nScore:$score"});
        _this.t = 0;
        
        
        _thread.enter(function _trc_GameMain_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.t<60)) { __pc=3     ; break; }
              _this.t++;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.t = 0;
              
            case 4:
              _it_190=Tonyu.iterator(_this.streams,1);
              while(_it_190.next()) {
                _this.st=_it_190[0];
                
                _this.st.Forward();
                
              }
              if (!(_this.t%300==0)) { __pc=6     ; break; }
              
              if (_this.rnd(3)>0) {
                _this.level=1;
              } else {
                _this.level=2;
              }
              _this.fiber$newStream(_thread, _this.rnd(200)+100, _this.rnd(200)+100, _this.randomNote(7*_this.level), _this.level);
              __pc=5;return;
            case 5:
              
            case 6     :
              
              _this.t++;
              Tonyu.globals.$panel.setFillStyle("#333");
              Tonyu.globals.$panel.fillRect(0,0,400,10);
              Tonyu.globals.$panel.setFillStyle("#ff0");
              Tonyu.globals.$panel.fillRect(0,0,Tonyu.globals.$accuracy*400,10);
              _this.fiber$update(_thread);
              __pc=7;return;
            case 7:
              
              __pc=4;break;
            case 8     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      randomNote :function _trc_GameMain_randomNote(cnt) {
        "use strict";
        var _this=this;
        var note;
        var i;
        
        note = [];
        
        i = 0;
        for (; i<cnt ; i++) {
          Tonyu.checkLoop();
          {
            if (i%2==0) {
              note.push(_this.rnd(4)+1);
            } else {
              if (_this.rnd(2)==0) {
                note.push(0);
              } else {
                note.push(_this.rnd(5));
              }
            }
          }
        }
        return note;
      },
      fiber$randomNote :function _trc_GameMain_f_randomNote(_thread,cnt) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var note;
        var i;
        
        note = [];
        
        i = 0;
        for (; i<cnt ; i++) {
          Tonyu.checkLoop();
          {
            if (i%2==0) {
              note.push(_this.rnd(4)+1);
            } else {
              if (_this.rnd(2)==0) {
                note.push(0);
              } else {
                note.push(_this.rnd(5));
              }
            }
          }
        }
        _thread.retVal=note;return;
        
        
        _thread.retVal=_this;return;
      },
      newStream :function _trc_GameMain_newStream(tx,ty,note,level) {
        "use strict";
        var _this=this;
        var interval;
        var st;
        
        interval = level==1?_this.interval:_this.interval/2;
        
        st = new Tonyu.classes.user.TouchStream({tx: tx,ty: ty,gameMain: _this,note: note,interval: interval});
        
        _this.streams.push(st);
      },
      fiber$newStream :function _trc_GameMain_f_newStream(_thread,tx,ty,note,level) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var interval;
        var st;
        
        interval = level==1?_this.interval:_this.interval/2;
        
        st = new Tonyu.classes.user.TouchStream({tx: tx,ty: ty,gameMain: _this,note: note,interval: interval});
        
        _this.streams.push(st);
        
        _thread.retVal=_this;return;
      },
      GainScoreFromRank :function _trc_GameMain_GainScoreFromRank(rank,sa) {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$score+=Tonyu.globals.$GameData.rank[rank].score;
        _this.GainAccuracy(sa);
      },
      fiber$GainScoreFromRank :function _trc_GameMain_f_GainScoreFromRank(_thread,rank,sa) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$score+=Tonyu.globals.$GameData.rank[rank].score;
        
        _thread.enter(function _trc_GameMain_ent_GainScoreFromRank(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$GainAccuracy(_thread, sa);
              __pc=1;return;
            case 1:
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      GainAccuracy :function _trc_GameMain_GainAccuracy(sa) {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$totalHit++;
        Tonyu.globals.$totalZure+=1-_this.clamp((_this.abs(sa)/10),1,0);
        Tonyu.globals.$accuracy=Tonyu.globals.$totalZure/Tonyu.globals.$totalHit;
      },
      fiber$GainAccuracy :function _trc_GameMain_f_GainAccuracy(_thread,sa) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$totalHit++;
        Tonyu.globals.$totalZure+=1-_this.clamp((_this.abs(sa)/10),1,0);
        Tonyu.globals.$accuracy=Tonyu.globals.$totalZure/Tonyu.globals.$totalHit;
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"randomNote":{"nowait":false},"newStream":{"nowait":false},"GainScoreFromRank":{"nowait":false},"GainAccuracy":{"nowait":false}},"fields":{"streams":{},"interval":{},"t":{},"level":{},"st":{}}}
});
Tonyu.klass.define({
  fullName: 'user.HitSuccessText',
  shortName: 'HitSuccessText',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_HitSuccessText_main() {
        "use strict";
        var _this=this;
        
        _this.text=Tonyu.globals.$GameData.rank[_this.rank].text;
        _this.size=Tonyu.globals.$GameData.rank[_this.rank].size;
        _this.fillStyle=Tonyu.globals.$GameData.rank[_this.rank].fillStyle;
        if (_this.rank==1) {
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_hitSuccess2);
        }
        if (_this.rank==2) {
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_hitSuccess);
        }
        _this.t = 60;
        
        _this.y-=20;
        while (_this.t>0) {
          Tonyu.checkLoop();
          _this.y-=1;
          _this.t--;
          _this.update();
          
        }
        _this.die();
      },
      fiber$main :function _trc_HitSuccessText_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.text=Tonyu.globals.$GameData.rank[_this.rank].text;
        _this.size=Tonyu.globals.$GameData.rank[_this.rank].size;
        _this.fillStyle=Tonyu.globals.$GameData.rank[_this.rank].fillStyle;
        if (_this.rank==1) {
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_hitSuccess2);
        }
        if (_this.rank==2) {
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_hitSuccess);
        }
        _this.t = 60;
        
        _this.y-=20;
        
        _thread.enter(function _trc_HitSuccessText_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.t>0)) { __pc=3     ; break; }
              _this.y-=1;
              _this.t--;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.die();
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_HitSuccessText_initialize(x) {
        "use strict";
        var _this=this;
        
        _this.rank=0;
        __superClass.apply( _this, [x]);
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false}},"fields":{"t":{},"rank":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Screen.resize(400,400);
        Tonyu.globals.$GameData=new Tonyu.classes.user.GameData();
        Tonyu.globals.$GameMain=new Tonyu.classes.user.GameMain({});
        new Tonyu.classes.kernel.Button({left: 360,top: 10,width: 40,height: 10,padding: 0,text: "Reset",onClick: (function anonymous_165() {
          
          _this.loadPage(Tonyu.classes.user.Main);
        })});
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Screen.resize(400,400);
        Tonyu.globals.$GameData=new Tonyu.classes.user.GameData();
        Tonyu.globals.$GameMain=new Tonyu.classes.user.GameMain({});
        
        _thread.enter(function _trc_Main_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              new Tonyu.classes.kernel.Button({left: 360,top: 10,width: 40,height: 10,padding: 0,text: "Reset",onClick: (function anonymous_165() {
                
                _this.loadPage(Tonyu.classes.user.Main);
              })});
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.PopText',
  shortName: 'PopText',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_PopText_main() {
        "use strict";
        var _this=this;
        
        _this.t = 60;
        
        while (_this.t>0) {
          Tonyu.checkLoop();
          _this.y-=1;
          _this.t--;
          _this.update();
          
        }
        _this.die();
      },
      fiber$main :function _trc_PopText_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.t = 60;
        
        
        _thread.enter(function _trc_PopText_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.t>0)) { __pc=3     ; break; }
              _this.y-=1;
              _this.t--;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.die();
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_PopText_initialize(x) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [x]);
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false}},"fields":{"t":{}}}
});
Tonyu.klass.define({
  fullName: 'user.TouchButton',
  shortName: 'TouchButton',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_TouchButton_main() {
        "use strict";
        var _this=this;
        
        _this.crashScale=2.5;
        _this.p=12;
        _this.touching=false;
        _this.on("touch",Tonyu.bindFunc(_this,_this.drag));
      },
      fiber$main :function _trc_TouchButton_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.crashScale=2.5;
        _this.p=12;
        _this.touching=false;
        _this.on("touch",Tonyu.bindFunc(_this,_this.drag));
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_TouchButton_initialize(x) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [x]);
        _this.f=Tonyu.globals.$touches[0];
      },
      drag :function _trc_TouchButton_drag(touchEvent) {
        "use strict";
        var _this=this;
        var f;
        
        f = touchEvent.finger;
        
        _this.f=f;
        _this.touching=true;
        _this.scaleX=1.5;
        _this.note.Hit();
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_hitBtn);
        f.on("move",(function anonymous_377(moveEvent) {
          
        }));
        f.on("end",(function anonymous_516(endEvent) {
          
          _this.touching=false;
          _this.scaleX=1;
        }));
      },
      fiber$drag :function _trc_TouchButton_f_drag(_thread,touchEvent) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var f;
        
        f = touchEvent.finger;
        
        _this.f=f;
        _this.touching=true;
        _this.scaleX=1.5;
        _this.note.Hit();
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_hitBtn);
        f.on("move",(function anonymous_377(moveEvent) {
          
        }));
        f.on("end",(function anonymous_516(endEvent) {
          
          _this.touching=false;
          _this.scaleX=1;
        }));
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"drag":{"nowait":false}},"fields":{"touching":{}}}
});
Tonyu.klass.define({
  fullName: 'user.TouchObj',
  shortName: 'TouchObj',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_TouchObj_main() {
        "use strict";
        var _this=this;
        
        _this.t = _this.time;
        
        _this.startx = _this.x;
        
        _this.starty = _this.y;
        
        _this.endx = _this.tx;
        
        _this.endy = _this.ty;
        
        _this.hitted = false;
        
        while (true) {
          Tonyu.checkLoop();
          _this.x=_this.endx+(_this.startx-_this.endx)*_this.t/_this.time;
          _this.y=_this.endy+(_this.starty-_this.endy)*_this.t/_this.time;
          _this.t--;
          if (_this.t<- _this.time) {
            _this.die();
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_TouchObj_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.t = _this.time;
        
        _this.startx = _this.x;
        
        _this.starty = _this.y;
        
        _this.endx = _this.tx;
        
        _this.endy = _this.ty;
        
        _this.hitted = false;
        
        
        _thread.enter(function _trc_TouchObj_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.x=_this.endx+(_this.startx-_this.endx)*_this.t/_this.time;
              _this.y=_this.endy+(_this.starty-_this.endy)*_this.t/_this.time;
              _this.t--;
              if (_this.t<- _this.time) {
                _this.die();
              }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_TouchObj_initialize(x) {
        "use strict";
        var _this=this;
        
        _this.tx=200;
        _this.ty=200;
        __superClass.apply( _this, [x]);
        _this.time=x.time?x.time:60;
      },
      Hitted :function _trc_TouchObj_Hitted() {
        "use strict";
        var _this=this;
        
        _this.hitted=true;
        _this.die();
      },
      fiber$Hitted :function _trc_TouchObj_f_Hitted(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.hitted=true;
        _this.die();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"Hitted":{"nowait":false}},"fields":{"t":{},"startx":{},"starty":{},"endx":{},"endy":{},"hitted":{}}}
});
Tonyu.klass.define({
  fullName: 'user.TouchStream',
  shortName: 'TouchStream',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_TouchStream_main() {
        "use strict";
        var _this=this;
        
        _this.noteObjs = [];
        
        _this.noteIndex = 0;
        
        _this.time = - _this.noteTime-15;
        
        _this.touchBtn = new Tonyu.classes.user.TouchButton({x: _this.tx,y: _this.ty,note: _this,p: 1});
        
        _this.end = 0;
        
      },
      fiber$main :function _trc_TouchStream_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.noteObjs = [];
        
        _this.noteIndex = 0;
        
        _this.time = - _this.noteTime-15;
        
        _this.touchBtn = new Tonyu.classes.user.TouchButton({x: _this.tx,y: _this.ty,note: _this,p: 1});
        
        _this.end = 0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_TouchStream_initialize(x) {
        "use strict";
        var _this=this;
        
        _this.tx=200;
        _this.ty=200;
        _this.interval=30;
        _this.noteTime=60;
        __superClass.apply( _this, [x]);
        _this.gameMain=x.gameMain?x.gameMain:Tonyu.globals.$GameMain;
        _this.note=x.note?x.note:[1,1,1,0,2,3,4];
      },
      Forward :function _trc_TouchStream_Forward() {
        "use strict";
        var _this=this;
        var type;
        var sx;
        var sy;
        
        if (_this.end==1) {
          if (_this.time>=_this.interval*_this.noteIndex) {
            _this.End();
          }
          
        } else {
          if (_this.time+_this.noteTime>=_this.interval*_this.noteIndex) {
            type = _this.note[_this.noteIndex];
            
            if (type==0) {
              
              
            } else {
              sx = 200;
              sy = 200;
              
              if (type==1) {
                sx=0;
              }
              if (type==2) {
                sy=0;
              }
              if (type==3) {
                sx=400;
              }
              if (type==4) {
                sy=400;
              }
              _this.noteObjs[_this.noteIndex]=new Tonyu.classes.user.TouchObj({x: sx,y: sy,time: _this.noteTime,tx: _this.tx,ty: _this.ty,p: 13});
              
            }
            _this.noteIndex++;
            if (_this.noteIndex>=_this.note.length) {
              _this.end=1;
              
            }
            
          }
        }
        _this.time++;
      },
      fiber$Forward :function _trc_TouchStream_f_Forward(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var type;
        var sx;
        var sy;
        
        
        _thread.enter(function _trc_TouchStream_ent_Forward(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.end==1)) { __pc=3     ; break; }
              if (!(_this.time>=_this.interval*_this.noteIndex)) { __pc=2     ; break; }
              _this.fiber$End(_thread);
              __pc=1;return;
            case 1:
              
            case 2     :
              
              __pc=4     ;break;
            case 3     :
              if (_this.time+_this.noteTime>=_this.interval*_this.noteIndex) {
                type = _this.note[_this.noteIndex];
                
                if (type==0) {
                  
                  
                } else {
                  sx = 200;
                  sy = 200;
                  
                  if (type==1) {
                    sx=0;
                  }
                  if (type==2) {
                    sy=0;
                  }
                  if (type==3) {
                    sx=400;
                  }
                  if (type==4) {
                    sy=400;
                  }
                  _this.noteObjs[_this.noteIndex]=new Tonyu.classes.user.TouchObj({x: sx,y: sy,time: _this.noteTime,tx: _this.tx,ty: _this.ty,p: 13});
                  
                }
                _this.noteIndex++;
                if (_this.noteIndex>=_this.note.length) {
                  _this.end=1;
                  
                }
                
              }
            case 4     :
              
              _this.time++;
              _thread.exit(_this);return;
            }
          }
        });
      },
      Hit :function _trc_TouchStream_Hit() {
        "use strict";
        var _this=this;
        var isa;
        
        isa = _this.NearCalc(_this.time,_this.interval);
        
        if (isa[0]<0) {
          return false;
        }
        if (_this.abs(isa[1])==0) {
          return _this.HitSuccess(isa[0],1,isa[1]);
          
        }
        if (_this.abs(isa[1])<3) {
          return _this.HitSuccess(isa[0],2,isa[1]);
          
        }
        if (_this.abs(isa[1])<9) {
          return _this.HitSuccess(isa[0],3,isa[1]);
          
        }
        return _this.HitSuccess(isa[0],0,isa[1]);
      },
      fiber$Hit :function _trc_TouchStream_f_Hit(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var isa;
        
        
        _thread.enter(function _trc_TouchStream_ent_Hit(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$NearCalc(_thread, _this.time, _this.interval);
              __pc=1;return;
            case 1:
              isa=_thread.retVal;
              
              if (!(isa[0]<0)) { __pc=2     ; break; }
              _thread.exit(false);return;
            case 2     :
              
              if (!(_this.abs(isa[1])==0)) { __pc=4     ; break; }
              _this.fiber$HitSuccess(_thread, isa[0], 1, isa[1]);
              __pc=3;return;
            case 3:
              _thread.exit(_thread.retVal);return;
              
            case 4     :
              
              if (!(_this.abs(isa[1])<3)) { __pc=6     ; break; }
              _this.fiber$HitSuccess(_thread, isa[0], 2, isa[1]);
              __pc=5;return;
            case 5:
              _thread.exit(_thread.retVal);return;
              
            case 6     :
              
              if (!(_this.abs(isa[1])<9)) { __pc=8     ; break; }
              _this.fiber$HitSuccess(_thread, isa[0], 3, isa[1]);
              __pc=7;return;
            case 7:
              _thread.exit(_thread.retVal);return;
              
            case 8     :
              
              _this.fiber$HitSuccess(_thread, isa[0], 0, isa[1]);
              __pc=9;return;
            case 9:
              _thread.exit(_thread.retVal);return;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      HitSuccess :function _trc_TouchStream_HitSuccess(index,rank,sa) {
        "use strict";
        var _this=this;
        
        if (! _this.noteObjs[index]||_this.noteObjs[index].hitted||_this.note[index]==0) {
          rank=0;
          sa+=_this.interval;
          
        }
        new Tonyu.classes.user.HitSuccessText({x: _this.tx,y: _this.ty,rank: rank});
        _this.gameMain.GainScoreFromRank(rank,sa);
        if (_this.noteObjs[index]) {
          _this.noteObjs[index].Hitted();
        }
        return rank;
      },
      fiber$HitSuccess :function _trc_TouchStream_f_HitSuccess(_thread,index,rank,sa) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (! _this.noteObjs[index]||_this.noteObjs[index].hitted||_this.note[index]==0) {
          rank=0;
          sa+=_this.interval;
          
        }
        new Tonyu.classes.user.HitSuccessText({x: _this.tx,y: _this.ty,rank: rank});
        _this.gameMain.GainScoreFromRank(rank,sa);
        if (_this.noteObjs[index]) {
          _this.noteObjs[index].Hitted();
        }
        _thread.retVal=rank;return;
        
        
        _thread.retVal=_this;return;
      },
      NearCalc :function _trc_TouchStream_NearCalc(time,interval) {
        "use strict";
        var _this=this;
        var index;
        var sa;
        
        index = _this.floor(time/interval);
        
        sa = - interval/2+(time+interval/2)%interval;
        
        if (sa==0||sa>0) {
          return [index,sa];
          
        } else {
          return [index+1,sa];
          
        }
      },
      fiber$NearCalc :function _trc_TouchStream_f_NearCalc(_thread,time,interval) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var index;
        var sa;
        
        index = _this.floor(time/interval);
        
        sa = - interval/2+(time+interval/2)%interval;
        
        if (sa==0||sa>0) {
          _thread.retVal=[index,sa];return;
          
          
        } else {
          _thread.retVal=[index+1,sa];return;
          
          
        }
        
        _thread.retVal=_this;return;
      },
      End :function _trc_TouchStream_End() {
        "use strict";
        var _this=this;
        
        _this.touchBtn.die();
        _this.die();
      },
      fiber$End :function _trc_TouchStream_f_End(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.touchBtn.die();
        _this.die();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"Forward":{"nowait":false},"Hit":{"nowait":false},"HitSuccess":{"nowait":false},"NearCalc":{"nowait":false},"End":{"nowait":false}},"fields":{"noteObjs":{},"noteIndex":{},"time":{},"touchBtn":{},"end":{},"noteTime":{},"tx":{},"ty":{},"interval":{},"note":{}}}
});

//# sourceMappingURL=concat.js.map